                      Computer Science 825
                         Quiz E           Name _______________________

1. Suppose a TCP connection has SND.UNA = 2200 and SND.NXT = 3450 and
   a packet arrives with ACK = 2800 and WINDOW = 4000. What size are
   the offered and usable windows now?

   offered -


   usable -


2. If IP loses a packet on a TCP connection, TCP recovers because

   a. The receiver always sends      b. The sender will eventually
      a special NAK packet if           time out and retransmit the
      a packet arrives out of           lost packet.
      order.

   c. Both mechanisms (a.) and (b.)  d. None of the above... TCP is
      are used.                         unable to recover from lost
                                        packets.

3. If a TCP receives a packet whose sequence number is less than its
   its current "ack" number   it should:

   a. buffer the packet but not      b. Buffer the packet and update
      change its current "ack"          it ack number to 1 + last byte
      ack number.                       received in the packet.

   c. discard the packet and not     d. Either b. or c. can be done.
      change its ack number.

4. If a TCP receives a packet whose sequence number is greater than
   its current "ack" number but still within the receiver window
   it should:

   a. buffer the packet but not      b. Buffer the packet and update
      change its current "ack"          it ack number to 1 + last byte
      ack number.                       received in the packet.

   c. discard the packet and not     d. Either b. or c. can be done.
      change its ack number.

5. Actions can be taken by either a sender or a receiver to terminate
   the dreaded condition known as the "Silly Window Syndrome". What
   action can each take.

   a. Sender -




   b. Receiver -





6. In Socket level TCP/IP programming the selection of the UDP or TCP
   transport protocol is made in which of the following function calls:

   a. socket()                   b. bind()

   c. connect()                  d. listen()


7. For each of the following functions indicate S if the function is
   used in constructing a TCP/IP server such as the one we studied,
   C if it is used in the client, and B if it is used in both the
   client and server.

   ____ a. accept()

   ____ b. connect()

   ____ c. bind()

   ____ d. socket()

   ____ e. listen()


8. Suppose round trip transit time for a connection is 40 milliseconds
   and the the transmission rate is 600,000 bytes per second. What
   is the minimum size (in bytes) that a TCP flow control window must be
   for the sender to avoid waiting after each window is sent.





